package me.Destro168.FC_Bans.Commands;

import me.Destro168.FC_Bans.FC_Bans;
import me.Destro168.FC_Bans.PunishmentManager;
import me.Destro168.FC_Bans.Utils.ConfigSettingsManager;
import me.Destro168.FC_Bans.Utils.BanMsgLib;
import me.Destro168.FC_Bans.Utils.FC_BansPermissions;
import me.Destro168.FC_Suite_Shared.ArgParser;

import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.craftbukkit.command.ColouredConsoleSender;
import org.bukkit.entity.Player;

public class BanCE implements CommandExecutor
{
	PunishmentManager record;
	BanMsgLib msgLib;
	Player player;
	ColouredConsoleSender console;
	
	public BanCE() { }
	 
	public boolean onCommand(CommandSender sender, Command cmd, String commandLabel, String[] args)
    {
		msgLib = new BanMsgLib(player);
		ArgParser fap = new ArgParser(args);
		BanMsgLib msgLib = null;
		FC_BansPermissions perms;
		String arg0 = fap.getArg(0);
		
		if (sender instanceof Player)
		{
			player = (Player) sender;
			perms = new FC_BansPermissions(player);
			msgLib = new BanMsgLib(player);
		}
		else if (sender instanceof ColouredConsoleSender)
		{
			console = (ColouredConsoleSender) sender;
			perms = new FC_BansPermissions(true);
			msgLib = new BanMsgLib(console);
		}
		else
		{
			FC_Bans.plugin.getLogger().info("Unknown command sender, returning ban command.");
			return false;
		}
		
		//Attempt to perform the commands.
		try
		{
			//Check if the player is immune
			if (perms.isImmune(arg0) == true)
				return msgLib.isImmune();
			
			//If the sub-command 'check' is entered, then show unmute date.
			if (arg0.equalsIgnoreCase("check"))
			{
				//If no permission, then cancel command use.
				if (perms.canBanCheck() == false)
					return msgLib.errorNoPermission();
				
				//First argument is check so get name from 2nd argument.
				record = new PunishmentManager(args[1]);
				
				//Check for ban
				msgLib.cm(0, args[1] + " will be unbanned on: " + record.getCorrectUnbanDate());
			}
			else if (arg0.equalsIgnoreCase("remove"))
			{
				//If no permission, then cancel command use.
				if (perms.canBanRemove() == false)
					return msgLib.errorNoPermission();
				
				//First argument is remove so get name from 2nd argument.
				record = new PunishmentManager(args[1]);
				
				//Unban the player.
				record.unban();
				
				msgLib.successCommand();
			}
			else
			{
				//If no permission, then cancel command use.
				if (perms.canBan() == false)
					return msgLib.errorNoPermission();
				
				//Check if argument ip is given.
				if (arg0 != null)
				{
					if (arg0.equals("ip"))
					{
						//Set final punish arg.
						fap.setLastArg(3);
						
						//Ban the player
						if (banPlayer(sender, args[1], args[2], fap.getFinalArg(), msgLib.getPunisherName()) == false)
							return msgLib.badDuration();
						
						//Handle ip stuff if the player has logged on before.
						if (Bukkit.getServer().getPlayer(args[1]) != null)
						{
							//Add the players ip to the configuration file.
							record.setIp(Bukkit.getServer().getPlayer(args[1]).getAddress().toString());
						}
					}
				}
				
				//Set final punish arg.
				fap.setLastArg(2);
				
				//Set bans to permanent if no time is specified.
				if (fap.getArg(1).equals(""))
					fap.setArg(1, "perm");
				
				//Ban the player
				if (banPlayer(sender, arg0, fap.getArg(1), fap.getFinalArg(), msgLib.getPunisherName()) == false)
					return msgLib.badDuration();
			}	
		}
		catch (NullPointerException e)
		{
			return msgLib.errorInvalidCommand();
		}
		catch (ArrayIndexOutOfBoundsException e) 
		{
			return msgLib.errorInvalidCommand();
		}
		
		return true;
    }
	
	public boolean banPlayer(CommandSender sender, String target, String duration, String reason, String punishGiver)
	{
		ConfigSettingsManager csm = new ConfigSettingsManager();
		
		//Get the record from the first passed argument.
		record = new PunishmentManager(target);
		
		//Ban the player
		if (record.punishPlayer(1, duration, reason, punishGiver) == false)
			return false;
		
		//If the global setting auto-show warning list is on, then show the warning list.
		if (csm.getAutoShowWarningList())
			record.showWarningList(sender);
		else
			msgLib.successCommand();
		
		return true;
	}
}








