package me.Destro168.FC_Bans.Commands;

import me.Destro168.FC_Bans.FC_Bans;
import me.Destro168.FC_Bans.PunishmentManager;
import me.Destro168.FC_Bans.Utils.ConfigSettingsManager;
import me.Destro168.FC_Bans.Utils.BanMsgLib;
import me.Destro168.FC_Bans.Utils.FC_BansPermissions;
import me.Destro168.FC_Suite_Shared.ArgParser;

import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.craftbukkit.command.ColouredConsoleSender;
import org.bukkit.entity.Player;

public class muteCE implements CommandExecutor
{
	PunishmentManager record;
	Player player;
	ColouredConsoleSender console;
	
	public muteCE() { }
	 
	public boolean onCommand(CommandSender sender, Command cmd, String commandLabel, String[] args)
    {
		ArgParser fap = new ArgParser(args);
		ConfigSettingsManager csm = new ConfigSettingsManager();
		BanMsgLib msgLib = null;
		FC_BansPermissions perms;
		
		if (sender instanceof Player)
		{
			player = (Player) sender;
			perms = new FC_BansPermissions(player);
			msgLib = new BanMsgLib(player);
		}
		else if (sender instanceof ColouredConsoleSender)
		{
			console = (ColouredConsoleSender) sender;
			perms = new FC_BansPermissions(true);
			msgLib = new BanMsgLib(console);
		}
		else
		{
			FC_Bans.plugin.getLogger().info("Unknown command sender, returning mute command.");
			return false;
		}
		
		//Attempt to perform the commands.
		try
		{
			//Check if the player is immune
			if (perms.isImmune(fap.getArg(0)) == true)
				return msgLib.isImmune();
			
			//If the sub-command 'check' is entered, then show unmute date.
			if (args[0].equalsIgnoreCase("check"))
			{
				//If no permission, then cancel command use.
				if (perms.canMuteCheck() == false)
					return msgLib.errorNoPermission();
				
				//First argument is check so get name from 2nd argument.
				record = new PunishmentManager(args[1]);
				
				//Check for mute
				msgLib.cm(0, args[1] + " will be unmuted on: " + record.getCorrectUnmuteDate());
			}
			else if (args[0].equalsIgnoreCase("remove"))
			{
				//If no permission, then cancel command use.
				if (perms.canMuteRemove() == false)
					return msgLib.errorNoPermission();
				
				//First argument is remove so get name from 2nd argument.
				record = new PunishmentManager(args[1]);
				
				//Unmute the player.
				record.unmute();
				
				msgLib.successCommand();
				
				//Tell the player they have been unmuted.
				if (Bukkit.getServer().getPlayer(args[1]) != null)
				{
					if (Bukkit.getServer().getPlayer(args[1]).isOnline())
					{
						msgLib = new BanMsgLib(Bukkit.getServer().getPlayer(args[1]));
						msgLib.cm(6, "You have been unmuted.");
					}
				}
			}
			else
			{
				//If no permission, then cancel command use.
				if (perms.canMute() == false)
					return msgLib.errorNoPermission();
				
				//Get name from 2nd argument.
				record = new PunishmentManager(args[0]);
				
				//Set final punish arg.
				fap.setLastArg(2);
				
				//Set mutes to permanent if no time is specified.
				if (fap.getArg(1).equals(""))
					fap.setArg(1, "perm");
				
				//Mute the player
				if (record.punishPlayer(2, fap.getArg(1), fap.getFinalArg(), msgLib.getPunisherName()) == false)
					return msgLib.badDuration();
				
				//If the global setting auto-show warning list is on, then show the warning list.
				if (csm.getAutoShowWarningList())
					record.showWarningList(sender);
				else
					msgLib.successCommand();
			}
		}
		catch (NullPointerException e)
		{
			return msgLib.errorInvalidCommand();
		}
		catch (ArrayIndexOutOfBoundsException e) 
		{
			return msgLib.errorInvalidCommand();
		}
	
		return true;
    }
}




