package me.Destro168.FC_Bans.Commands;

import me.Destro168.FC_Bans.FC_Bans;
import me.Destro168.FC_Bans.PunishmentManager;
import me.Destro168.FC_Bans.Utils.ConfigSettingsManager;
import me.Destro168.FC_Bans.Utils.BanMsgLib;
import me.Destro168.FC_Bans.Utils.FC_BansPermissions;
import me.Destro168.FC_Suite_Shared.ArgParser;

import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.craftbukkit.command.ColouredConsoleSender;
import org.bukkit.entity.Player;

public class warnCE implements CommandExecutor
{
	PunishmentManager record;
	Player player;
	ColouredConsoleSender console;
	
	public warnCE() { }
	
	public boolean onCommand(CommandSender sender, Command cmd, String commandLabel, String[] args)
    {
		//Get the configuration file.
		BanMsgLib msgLib = new BanMsgLib(player);
		ArgParser fap = new ArgParser(args);
		ConfigSettingsManager csm = new ConfigSettingsManager();
		FC_BansPermissions perms;
		
		if (sender instanceof Player)
		{
			player = (Player) sender;
			perms = new FC_BansPermissions(player);
			msgLib = new BanMsgLib(player);
		}
		else if (sender instanceof ColouredConsoleSender)
		{
			console = (ColouredConsoleSender) sender;
			perms = new FC_BansPermissions(true);
			msgLib = new BanMsgLib(console);
		}
		else
		{
			FC_Bans.plugin.getLogger().info("Unknown command sender, returning warn command.");
			return false;
		}
		
		//Attempt to perform the commands.
//		try
//		{
			//Check if the player is immune
			if (perms.isImmune(fap.getArg(0)) == true)
				return msgLib.isImmune();
			
			//If the sub-command 'check' is entered, then we want to only show the warning list.
			if (args[0].equalsIgnoreCase("check"))
			{
				//Without permission deny the command.
				if (perms.canWarn() == false)
					return msgLib.errorNoPermission();
				
				//First argument is check so get name from 2nd argument.
				record = new PunishmentManager(args[1]);
				
				//Send the player the warning list.
				record.showWarningList(sender);;
			}
			else if (args[0].equalsIgnoreCase("remove"))
			{
				//Without permission deny the command.
				if (perms.canWarnRemove() == false)
					return msgLib.errorNoPermission();
				
				//First argument is check so get name from 2nd argument.
				record = new PunishmentManager(args[1]);
				
				try
				{
					//Attempt to delete the warning.
					record.deleteWarning(Integer.valueOf(args[2]) - 1);
					
					//Send the player confirmation.
					msgLib.successCommand();
				}
				catch (NumberFormatException e)
				{
					return msgLib.errorInvalidCommand();
				}
			}
			else
			{
				//Without permission deny the command.
				if (perms.canWarn() == false)
					return msgLib.errorNoPermission();
				
				//Get the record from the first passed argument.
				record = new PunishmentManager(args[0]);
				
				//Set final punish arg.
				fap.setLastArg(1);
				
				//Ban the player
				record.warnPlayer(fap.getFinalArg(), msgLib.getPunisherName());
				
				//If the global setting auto-show warning list is on, then show the warning list.
				if (csm.getAutoShowWarningList())
					record.showWarningList(sender);
				else
					msgLib.successCommand();
			}
		/*
    	}
		catch (NullPointerException e)
		{
			return msgLib.errorInvalidCommand();
		}
		catch (ArrayIndexOutOfBoundsException e) 
		{
			return msgLib.errorInvalidCommand();
		}
		*/
		
		return true;
    }
}
