package me.Destro168.FC_Bans;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

import me.Destro168.FC_Bans.Utils.ConfigSettingsManager;
import me.Destro168.FC_Suite_Shared.MessageLib;
import me.Destro168.FC_Suite_Shared.NameMatcher;
import me.Destro168.FC_Suite_Shared.SharedPlayerProfileManager;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.craftbukkit.command.ColouredConsoleSender;
import org.bukkit.entity.Player;

public class PunishmentManager
{
	//Variable declarations
	private final int MAX_WARNINGS = 100;
	private SharedPlayerProfileManager profile;
	private final DateFormat dfm = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
	private String playerName;
	private String playerPath;
	private ConfigSettingsManager csm;
	
	public void setName(String x) { playerName = x; }
	public String getName() { return playerName; }
	
	public String getWarningReason(int x) { return profile.getString(playerPath + x + ".reason"); }
	public String getWarningTime(int x) { return profile.getString(playerPath + x + ".time"); }
	public String getWarningType(int x) { return profile.getString(playerPath + x + ".type"); }
	public String getWarnGiverName(int x) { return profile.getString(playerPath + x + ".warnGiverName"); }
	public int getWarningLevel(int x) { return profile.getInt(playerPath + x + ".level"); }
	public boolean getIsPermaBanned() { return profile.getBoolean(playerPath + "isPermaBanned"); }
	public boolean getIsPermaMuted() { return profile.getBoolean(playerPath + "isPermaMuted"); }
	public long getUnmuteDate() { return profile.getLong(playerPath + "unmuteDate"); }
	public long getUnbanDate() { return profile.getLong(playerPath + "unbanDate"); }
	public String getIp() { return profile.getString(playerPath + "ip"); }
	
	public void setWarningReason(int x, String y) { profile.set(playerPath + x + ".reason", y); }
	public void setWarningTime(int x, String y) { profile.set(playerPath + x + ".time", y); }
	public void setWarningType(int x, String y) { profile.set(playerPath + x + ".type", y); }
	public void setWarnGiverName(int x, String y) { profile.set(playerPath + x + ".warnGiverName", y); }
	public void setWarningLevel(int x, int y) { profile.set(playerPath + x + ".level", y); }
	public void setUnbanDate(long x) { profile.set(playerPath + "unbanDate", x); }
	public void setUnmuteDate(long x) { profile.set(playerPath + "unmuteDate", x); }
	public void setIsPermaBanned(boolean x) { profile.set(playerPath + "isPermaBanned", x); }
	public void setIsPermaMuted(boolean x) { profile.set(playerPath + "isPermaMuted", x); }
	public void setIp(String x) { profile.set(playerPath + "ip", x); }
	
	public void deleteWarning(int x) { profile.set(playerPath + x, null); }
	public String getUnbanDateNormal() { if (getUnbanDate() > 0) return dfm.format(getUnbanDate()); else return "Not banned"; }
	public String getUnmuteDateNormal() { if (getUnmuteDate() > 0) return dfm.format(getUnmuteDate()); else return "Not Muted"; }
	
	public PunishmentManager(String playerName_)
	{
		//Variable declarations
		NameMatcher nm = new NameMatcher();
		csm = new ConfigSettingsManager();

		//Use player name before modified for real name.
		profile = new SharedPlayerProfileManager(playerName_);
		
		//Get easily compatible player name.
		if (nm.getNameByMatch(playerName_).equals(""))
			playerName = playerName_;
		else
			playerName = nm.getNameByMatch(playerName_);
		
		playerName = playerName.toLowerCase();
		
		//Use the player name.
		playerPath = "FC_Bans.";
	}
	
	public void transferPlayerData()
	{
		//Variable Declarations
		FileConfiguration config;
		
		config = FC_Bans.plugin.getConfig();
		
		String oldPlayerPath = "Warnings." + playerName + ".";
		
		if (config.getString(oldPlayerPath + "unbanDate") == null)
			return;
		
		if (config.getString(oldPlayerPath + "unbanDate").equals(""))
			return;
		
		profile.set("FC_Bans.unbanDate", config.getInt(oldPlayerPath + "unbanDate"));
		profile.set("FC_Bans.unmuteDate", config.getInt(oldPlayerPath + "unmuteDate"));
		profile.set("FC_Bans.isPermaBanned", config.getBoolean(oldPlayerPath + "isPermaBanned"));
		profile.set("FC_Bans.isPermaMuted", config.getBoolean(oldPlayerPath + "isPermaMuted"));
		profile.set("FC_Bans.ip", config.getString(oldPlayerPath + "ip"));
		
		for (int i = 0; i < MAX_WARNINGS; i++)
		{
			if (!(config.getString(oldPlayerPath + i + ".warnGiverName") == null))
			{
				if (!config.getString(oldPlayerPath + i + ".warnGiverName").equals(""))
				{
					profile.set("FC_Bans." + i + ".level", config.getInt(oldPlayerPath + i + ".level"));
					profile.set("FC_Bans." + i + ".type", config.getString(oldPlayerPath + i + ".type"));
					profile.set("FC_Bans." + i + ".reason", config.getString(oldPlayerPath + i + ".reason"));
					profile.set("FC_Bans." + i + ".time", config.getString(oldPlayerPath + i + ".time"));
					profile.set("FC_Bans." + i + ".warnGiverName", config.getString(oldPlayerPath + i + ".warnGiverName"));
				}
			}
		}
	}
	
	public void updatePlayerWarnings()
	{
		String warning = "";
		
		////////////////////////////////////////////////////////////////////////////////////////////////////////////
		// Rearrange warnings so there are no spaces
		// - We find a non-blank warning and then check every warning before that to see if it is empty.
		// - If there is an empty warning, then we want to switch it to that posiiton.
		////////////////////////////////////////////////////////////////////////////////////////////////////////////
		
		//'i' is the first non-blank warning.
		for (int i = 0; i < MAX_WARNINGS; i++)
		{
			//Find a non-blank warning.
			warning = getWarningReason(i);
			
			if (warning != null)
			{
				if (!warning.equals(""))
				{
					//J is the blank warning, move onto j
					for (int j = 0; j < i; j++)
					{
						//Find a non-blank warning.
						warning = getWarningReason(j);
						
						if (warning == null)
						{
							moveWarning(j, i);
							j = MAX_WARNINGS;
						}
						else if (getWarningReason(j).equals(""))
						{
							moveWarning(j, i);
							j = MAX_WARNINGS;
						}
					}
				}
			}
		}
	}
	
	//we set b onto a then clear b.
	public void moveWarning(int a, int b)
	{
		setWarningReason(a, getWarningReason(b));
		setWarningTime(a, getWarningTime(b));
		setWarningType(a, getWarningType(b));
		setWarningLevel(a, getWarningLevel(b));
		setWarnGiverName(a, getWarnGiverName(b));
		
		deleteWarning(b);
	}
	
	public void addWarning(String type, String time, String reason, int warningLevel, String warnGiverName)
	{
		String warning = "";
		String broadcastText = "";
		
		//Add the warning to the first empty warning slot.s
		for (int i = 0; i < MAX_WARNINGS; i++)
		{
			broadcastText = "";
			
			if (getWarningReason(i) == null)
			{
				setWarningReason(i, reason);
				setWarningTime(i, time);
				setWarningType(i, type);
				setWarningLevel(i, warningLevel);
				setWarnGiverName(i, warnGiverName);
				
				if (csm.getGlobalAnnouncementsEnabled() == true)
				{
					warning = getWarningReason(i);
					
					//Only display a warning if it's not null and not empty.
					if (warning != null)
					{
						//Send them the warning with the tag and warning.
						broadcastText += ChatColor.GRAY + "[" + getWarningType(i) + ChatColor.WHITE + "] " +
								ChatColor.YELLOW + playerName + ChatColor.GRAY + " has been punished!";
						
						if (!warning.equals("null") && !warning.equals(""))
							broadcastText += " Reason: " + warning;
						
						if (csm.getDisplayWarnGiverNameOnPunish() == true)
							broadcastText += " By: " + warnGiverName;
						
						//Display the broadcast.
						Bukkit.getServer().broadcastMessage(broadcastText);
					}
				}
				
				//End execution
				return;
			}
		}
	}

	public int getTotalWarnLevel()
	{
		int totalLevel = 0;
		
		//Parse all warnings.
		for (int i = 0; i < MAX_WARNINGS; i++)
		{
			//Add the warning level.
			totalLevel += getWarningLevel(i);
		}
		
		return totalLevel;
	}
	
	//A more general function to send a player a list of warnings.
	public void showWarningList(CommandSender sender)
	{
		//Variable Declarations
		int count = 1; // User list starts at 0.
		int totalWarnLevel = getTotalWarnLevel();
		boolean displayYellow = true;
		String[] warnings = new String[MAX_WARNINGS + 1];
		MessageLib msgLib;
		String warning = "";
		String message = "";
		
		//We want to rearrange the warnings before displaying them.
		updatePlayerWarnings();
		
		//Send the warning level.
		if (totalWarnLevel < csm.getLowWarningLevel())
			warnings[0] = ChatColor.GRAY + "Warning Level: " + ChatColor.GRAY + totalWarnLevel;
		else if (totalWarnLevel < csm.getMediumWarningLevel())
			warnings[0] = ChatColor.GRAY + "Warning Level: " + ChatColor.GREEN + totalWarnLevel;
		else if (totalWarnLevel < csm.getHighWarningLevel())
			warnings[0] = ChatColor.GRAY + "Warning Level: " + ChatColor.YELLOW + totalWarnLevel;
		else if (totalWarnLevel < csm.getExtremeWarningLevel())
			warnings[0] = ChatColor.GRAY + "Warning Level: " + ChatColor.RED + totalWarnLevel;
		else
			warnings[0] = ChatColor.GRAY + "Warning Level: " + ChatColor.DARK_RED + totalWarnLevel;
		
		//Parse all warnings.
		for (int i = 0; i < MAX_WARNINGS; i++)
		{	
			//Reset both warning and message fields.
			warning = "";
			message = "";
			
			warning = getWarningReason(i);
			
			//Only display a warning if it's not null and not empty.
			if (warning != null)
			{
				if (!warning.equals("null"))
				{
					//Alternate the colors.
					if (displayYellow == true)
						message += ChatColor.GRAY + "Warning #" + ChatColor.YELLOW + String.valueOf(count) + " ";
					else
						message += ChatColor.GRAY + "Warning #" + ChatColor.GREEN + String.valueOf(count) + " ";
					
					//Create warning tag.
					message += ChatColor.WHITE + "[" + ChatColor.GRAY + getWarningType(i) + ChatColor.WHITE + "] - ";
					
					//Add in the warn giver name.
					message += ChatColor.WHITE + "[Giver: " + ChatColor.GRAY + getWarnGiverName(i) + ChatColor.WHITE + "] - ";
					
					//Send them the warning with the tag and warning.
					warnings[i + 1] = message + "Reason: " + warning;
					
					//Increase the count to display the next warning properly without counting empty announcements.
					count++;
				}
			}
		}
		
		//Set up the messageLib
		if (sender instanceof Player)
			msgLib = new MessageLib((Player) sender);
		else if (sender instanceof ColouredConsoleSender)
			msgLib = new MessageLib((ColouredConsoleSender) sender);
		else
			return;
		
		//Send the message.
		for (int i = 0; i < warnings.length; i++)
		{
			if (warnings[i] != null)
			{
				if (!warnings[i].equals("null"))
					msgLib.cm(6, warnings[i]);
			}
		}
	}
	
	public boolean isBanned()
	{
		Date now = new Date();
		
		//Always check if perma-banned first.
		if (getIsPermaBanned() == true)
			return true;
		
		//If they haven't served their time yet, then return true.
		if (now.getTime() < getUnbanDate())
		{
			//Return true;
			return true;
		}
		
		//Perform a check to see if they are ip-banned.
		if (getIp() != null)
		{
			if (!getIp().equals("0"))
				return true;
		}
		
		/*
		//If they have an unbandate of 0, then...
		if (getUnbanDate() <= 0)
		{
			//Return that they aren't banned.
			return false;
		}
		*/
		
		//If they pass all checks, use unban to clear all information.
		unban();
		
		return false;
	}
	
	public boolean isMuted()
	{
		Date now = new Date();
		
		//Always check if permanently muted first.
		if (getIsPermaMuted() == true)
			return true;
				
		//If they have an unmutedate of 0, then return false.
		if (getUnmuteDate() <= 0)
			return false;
		
		//If they have served their time, unmute them and return false.
		if (now.getTime() >= getUnmuteDate())
		{
			setUnmuteDate(0);
			return false;
		}

		return true;
	}
	
	public void unban()
	{
		//Set unban date to 0.
		setUnbanDate(0);
		
		//Set ip to 0
		setIp("0");
		
		//Remove perma-bans.
		setIsPermaBanned(false);
	}
	
	public void unmute()
	{
		//Set unmute date to 0.
		setUnmuteDate(0);
		
		//Remove perma-mute
		setIsPermaMuted(false);
	}
	
	/////////////////////////////////////////////////////////////////
	// Handle Punishments
	// Type 0 = Warn, Type 1 = Ban, Type 2 = Mute, Type 3 kick
	/////////////////////////////////////////////////////////////////
	
	private void checkCreatedBefore()
	{
		if (getUnbanDate() == 0)
			createNewProfile();
	}
	
	public void createNewProfile()
	{
		setUnbanDate(0);
		setUnmuteDate(0);
		setIsPermaBanned(false);
		setIsPermaMuted(false);
		
		if (Bukkit.getServer().getPlayer(playerName) != null)
			setIp(Bukkit.getServer().getPlayer(playerName).getAddress().toString());
	}
	
	public void warnPlayer(String reason, String warnGiver)
	{
		Date now = new Date();
		Player player;
		
		checkCreatedBefore();
		
		//If the reason is empty, then we want to set it to [NONE]"
		if (reason.equals(""))
			reason = "[None]";
		
		//Add the warning
		addWarning("Warn", dfm.format(now), reason, csm.getWarningLevelWarn(), warnGiver);
		
		if (Bukkit.getPlayer(playerName) != null)
		{	
			player = Bukkit.getPlayer(playerName);
			
			if (player.isOnline() == true)
			{
				//Tell the player that they have been warned by the warn giver.
				if (csm.getDisplayWarnGiverNameOnPunish() == true)
					player.sendMessage(ChatColor.GRAY + "You have just been warned by " + warnGiver + ":");
				else
					player.sendMessage(ChatColor.GRAY + "You have just been warned:");
				
				//Send the player the reason they were warned.
				player.sendMessage(ChatColor.GRAY + "Reason: " + reason);
			}
		}
	}
	
	public boolean punishPlayer(int type, String duration, String reason, String punishGiver)
	{
		Date now = new Date();
		char[] d = duration.toCharArray();
		int currentPosition = 0;
		int warnLevel = 0;
		String durationTimeText = "";
		
		String str_Seconds = "";
		String str_Minutes = "";
		String str_Hours = "";
		String str_Days = "";
		String str_Weeks = "";
		
		int int_Seconds = 0;
		int int_Minutes = 0;
		int int_Hours = 0;
		int int_Days = 0;
		int int_Weeks = 0;
		
		checkCreatedBefore();
		
		if (type == 0)
		{
			warnPlayer(reason, punishGiver);
			return true;
		}
		else if (type == 3)
		{
			kickPlayer(reason, punishGiver);
			return true;
		}
		
		//If the duration is permanent, then we want to treat the punishment as permanent.
		if (duration.contains("perm"))
		{
			//Set durationTimeText to permanent.
			durationTimeText = " - Duration: [Permanent]";
			
			if (type == 1)
			{
				//Add the warning
				addWarning("Ban", dfm.format(now), reason +  durationTimeText, csm.getWarningLevelBan(), punishGiver);
				
				//Set the players ban record, permanent, true.
				setIsPermaBanned(true);
				
				//Alert the player that they are banned.
				dealPunishment(1, reason, durationTimeText, punishGiver);
			}
			else if (type == 2)
			{
				//Add the warning
				addWarning("Mute", dfm.format(now), reason + durationTimeText, csm.getWarningLevelMute(), punishGiver);
				
				//Set the players ban record, permanent, true.
				setIsPermaMuted(true);
				
				//Alert the player they are muted.
				dealPunishment(2, reason, durationTimeText, punishGiver);
			}
		}
		
		//Else parse user input to get duration text.
		else
		{
			//Use try clause to parse input.
			try
			{
				//Parse the duration / Standard format: 1s5m8h10d3w
				for (int i = 0; i < d.length; i++)
				{
					if (d[i] == 's')
					{
						for (int j = currentPosition; j < i; j++)
							str_Seconds += d[j];
						
						int_Seconds = Integer.valueOf(str_Seconds);
						
						currentPosition = i + 1;
					}
					
					else if (d[i] == 'm')
					{
						for (int j = currentPosition; j < i; j++)
							str_Minutes += d[j];
						
						int_Minutes = Integer.valueOf(str_Minutes);
						
						currentPosition = i + 1;
					}
					
					if (d[i] == 'h')
					{
						for (int j = currentPosition; j < i; j++)
							str_Hours += d[j];
						
						int_Hours = Integer.valueOf(str_Hours);
						
						currentPosition = i + 1;
					}
					
					if (d[i] == 'd')
					{
						for (int j = currentPosition; j < i; j++)
							str_Days += d[j];
						
						int_Days = Integer.valueOf(str_Days);
						
						currentPosition = i + 1;
					}
					
					if (d[i] == 'w')
					{
						for (int j = currentPosition; j < i; j++)
							str_Weeks += d[j];
						
						int_Weeks = Integer.valueOf(str_Weeks);
						
						currentPosition = i + 1;
					}
				}
			}
			catch (NumberFormatException e)
			{
				//Return false on fails
				return false;
			}
			
			//Store the proper amount of time all in the seconds variable and form the proper duration text.
			if (int_Seconds > 0)
				durationTimeText += " " + str_Seconds + " second(s)";
			
			if (int_Minutes > 0)
			{
				int_Seconds = int_Minutes*60;
				durationTimeText += " " + str_Minutes + " minute(s)";
			}
			
			if (int_Hours > 0)
			{
				int_Seconds = int_Hours*3600;
				durationTimeText += " " + str_Hours + " hour(s)";
			}
			
			if (int_Days > 0)
			{
				int_Seconds = int_Days*86400;
				durationTimeText += " " + str_Days + " day(s)";
			}
			
			if (int_Weeks > 0)
			{
				int_Seconds = int_Weeks*604800;
				durationTimeText += " " + str_Weeks + " week(s)";
			}
			
			//Set duration time text
			durationTimeText = " - Duration:" + durationTimeText;
			
			//Set punishment end to future date
			Calendar gc = new GregorianCalendar();
			
			//Referesh now.
			now = new Date();
			
			//Set starting time
			gc.setTime(now);
			
			//Add the time.
			gc.add(Calendar.SECOND, int_Seconds);
			
			//If a ban
			if (type == 1)
			{
				//Create temp variable to count number of days to determine warn level.
				int countDays = int_Seconds;
				
				//Set base warn level to ban warn level.
				warnLevel = csm.getWarningLevelBan();
				
				while (countDays > 86400)
				{
					countDays = countDays - 86400;
					warnLevel = warnLevel + csm.getWarnBonusPerDayBan();
				}
				
				//Add the warning
				addWarning("Ban", dfm.format(now), reason + durationTimeText, warnLevel, punishGiver);
				
				//set the players unban time equal to current time + ban length.
				setUnbanDate(gc.getTimeInMillis());
				
				//Get the player
				dealPunishment(1, reason, durationTimeText, punishGiver);
			}
			
			//If a mute
			else if (type == 2)
			{
				//Create temp variable to count number of days to determine warn level.
				int countDays = int_Seconds;
				
				//Set base warn level to ban warn level.
				warnLevel = csm.getWarningLevelMute();
				
				while (countDays > 86400)
				{
					countDays = countDays - 86400;
					warnLevel = warnLevel + csm.getWarnBonusPerDayMute();
				}
				
				//Add the warning
				addWarning("Mute", dfm.format(now), reason + durationTimeText, warnLevel, punishGiver);
				
				//Set the players unmute time equal to current time + mute length.
				setUnmuteDate(gc.getTimeInMillis());
				
				//Alert the player they are muted.
				dealPunishment(2, reason, durationTimeText, punishGiver);
			}
		}
		
		return true;
	}
	
	private void dealPunishment(int type, String reason, String durationTimeText, String punishGiver)
	{
		if (type == 1)
		{
			if (Bukkit.getPlayer(playerName) != null)
			{
				if (Bukkit.getPlayer(playerName).isOnline() == true)
				{
					if (csm.getDisplayWarnGiverNameOnPunish() == true)
						Bukkit.getPlayer(playerName).kickPlayer("You have been banned by " + punishGiver + " for" + durationTimeText + " for " + reason);
					else
						Bukkit.getPlayer(playerName).kickPlayer("You have been banned for " + durationTimeText + " for" + reason);
				}
			}
		}
		else if (type == 2)
		{
			if (Bukkit.getPlayer(playerName) != null)
			{
				if (Bukkit.getPlayer(playerName).isOnline() == true)
				{
					if (csm.getDisplayWarnGiverNameOnPunish() == true)
						Bukkit.getPlayer(playerName).sendMessage(ChatColor.GRAY + "You have been muted by " + punishGiver + " for" + durationTimeText + " for " + reason);
					else
						Bukkit.getPlayer(playerName).sendMessage(ChatColor.GRAY + "You have been muted for " + durationTimeText + " for" + reason);
				}
			}
		}
	}

	public void kickPlayer(String reason, String kicker)
	{
		Date now = new Date();
		
		checkCreatedBefore();
		
		//If the reason is empty, then we want to set it to [NONE]"
		if (reason.equals(""))
			reason = "[None]";
		
		//Add the warning
		addWarning("Kick", dfm.format(now), reason, csm.getWarningLevelKick(), kicker);
		
		//Kick the player
		if (Bukkit.getPlayer(playerName) != null)
		{
			if (Bukkit.getPlayer(playerName).isOnline() == true)
			{
				if (csm.getDisplayWarnGiverNameOnPunish() == true)
					Bukkit.getPlayer(playerName).kickPlayer("You have been kicked by " + kicker + " for " + reason);
				else
					Bukkit.getPlayer(playerName).kickPlayer("You have been kicked for " + reason);
			}
		}
	}
	
	public String getCorrectUnmuteDate()
	{
		if (getIsPermaMuted() == true)
		{
			return "Never";
		}
		else
		{
			return getUnmuteDateNormal();
		}
	}
	
	public String getCorrectUnbanDate()
	{
		if (getIsPermaBanned() == true)
		{
			return "Never";
		}
		else
		{
			return getUnbanDateNormal();
		}
	}
}

/*
Add warnings to the player based on level of infraction.

Minor Rulebreak = 1;
Medium Rulebreak = 3;
Major Rulebreak = 5;

Kick = 1
Mute = 1

*/
